#ifndef __LINUX_SPINLOCK_H
#define __LINUX_SPINLOCK_H

#include <sys/lock.h>
#include <sys/mutex.h>

/* fromm spinlock_types.h */
typedef struct {
        // raw_spinlock_t raw_lock;
	struct mtx m;
} spinlock_t;

static inline void spin_lock_init(spinlock_t *lock)
{
	mtx_init(&lock->m, "ldev-spin", NULL, MTX_SPIN);
}

static inline void spin_lock(spinlock_t *lock)
{
	mtx_lock_spin(&lock->m);
}

static inline void spin_unlock(spinlock_t *lock)
{
	mtx_unlock_spin(&lock->m);
}

#define spin_lock_irq(lock)	spin_lock(lock)
#define spin_lock_irqsave(lock, flags)   do {flags = 0; spin_lock(lock); } while (0)
#define spin_unlock_irqrestore(lock, flags)      do { spin_unlock(lock); } while (0)
#define spin_unlock_irq(lock)    spin_unlock(lock)

#endif /* __LINUX_SPINLOCK_H */
